﻿using System.Collections.Generic;
using System.Reflection;
using System.Windows.Media;

namespace Writespace.Dialogs
{
    /// <summary>
    /// This idea is from .NET Rocker blog, http://www.thomasclaudiushuber.com/blog/2008/01/10/bind-to-methods-with-objectdataprovider/
    /// Thanks to Thomas Claudius Huber 
    /// </summary>
    public static class ColorHelper
    {
        public static IEnumerable<string> GetColorNames()
        {
            foreach (var p in typeof (Colors).GetProperties(BindingFlags.Public | BindingFlags.Static))
                yield return p.Name;
        }
    }

    public static class SizeHelper
    {
        public static IEnumerable<int> GetFontSizes()
        {
            for (var i = 6; i <= 64; i = i + 2)
                yield return i;
        }
    }
}
